'********************************************************************
'* This program simply shows that a Quick Basic program can be used *
'* as an external sub-routine by a BAX program.  It passes a string *
'* of characters back to the calling BAX program via the BAX work   *
'* area.  The pointer to the BAX work area is passed to this        *
'* program as a command line argument.                              *
'* The same thing can be done with BASIC PDS or with VBDOS.         *
'*                                                                  *
'* Notice that the POKE statement offset value is defined by the    *
'* expression:    X - 1                                             *
'* This is to allow for the fact that when using most BASIC         *
'* languages, the offset to the first character in the segment is   *
'* #0.  This same offset is treated as #1 by the calling BAX        *
'* program.  In other words, BAX starts counting with #1.  BASIC    *
'* starts counting with #0 (as do most languages).                  *
'********************************************************************
DEFINT A-Z                      'ONLY NEED INTEGERS
BAXSEG = VAL(COMMAND$)          'BAX SEGMENT PASSED TO US
IF BAXSEG <> 0 THEN             'IF NON-ZERO THEN ASSUME OK
'
A$ = "TEST VALUE RETURNED BY QBTEST.EXE"        'WE RETURN THIS STRING
'
DEF SEG=BAXSEG                  'SET UP BAX SEGMENT FOR POKING
FOR X = 1 TO LEN(A$)            'LOOP THRU THE STRING, 1 CHAR AT A TIME
P$ = MID$(A$,X,1)               'GET NEXT CHAR
POKE X - 1 , ASC(P$)            'POKE IT INTO BAX WORK AREA
NEXT X
DEF SEG                         'RESTORE BASIC SEGMENT
ELSE
PRINT "INVALID SEGMENT VALUE -- CANNOT RETURN DATA"
END IF
END
