@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program will allow you to edit any environment variable   *
'* which currently exists.  To execute from the dos prompt, type: *
'*                                                                *
'*                     ANYVAR varname                             *
'*                                                                *
'* where "varname" is the name of the environment variable to be  *
'* changed.  For example, if you wanted to change your PATH       *
'* variable, you would type:                                      *
'*                                                                *
'*                     ANYVAR PATH                                *
'*                                                                *
'* Any changes which you make will be effective if you exit by    *
'* pressing the ENTER key.  If you do not want to save your       *
'* changes, exit by pressing the ESCAPE key.                      *
'*                                                                *
'******************************************************************
=ANYVAR
CALL =COLORSUB  ' SET UP COLOR NAMES
'
%S1 = LIT *****************************************************
%S2 = LIT *            EDIT ANY ENVIRONMENT VARIABLE          *
%S3 = LIT *                                                   *
%S4 = LIT * PRESS ESCAPE TO ABORT WITHOUT MAKING CHANGES      *
%S5 = LIT * PRESS ENTER  TO SAVE CHANGES                      *
%S6 = LIT *                                                   *
%S7 = LIT *****************************************************
'
IF %LA = 0 THEN GOTO =NOARG          ' ERROR -- NO ARGUMENT
COLORS %BLACK %RED                   ' USE A RED BACKGROUND
CLS                                  ' PAINT THE SCREEN RED
COLORS %YELLOW %BROWN                ' YELLOW ON BROWN FOR BOX COLOR
%X = 0                               ' SET LOOP COUNTER
LOOP =BOTBOX                         ' TOP OF LOOP TO DRAW BOX
%X = ADD %X 1                        ' INCREMENT COUNTER
IF %X > 7 THEN LEAVE =BOTBOX         ' BREAK LOOP
CURSORVH 0 15                        ' POSITION CURSOR IN COLUMN 15
OUTMSG %S%X                          ' DISPLAY TEXT ON SCREEN
OUTPUT                               ' MOVE CURSOR DOWN ONE LINE
=BOTBOX                              ' BOTTOM OF LOOP
OUTPUT                               ' DISPLAY BLANK LINE (COSMETIC)
'
%VARVAL = ENVGET P %A1               ' GET CURRENT VALUE FOR VARIABLE
%LENVAL = LEN %VARVAL                ' LENGTH OF CURRENT VALUE
'
%VNAME = JOIN %A1 =                  ' APPEND AN EQUAL SIGN TO VAR NAME
%L = LEN %VNAME                      ' LENGTH OF VARNAME + EQUAL SIGN
%MAXLEN = SUB 80 %L                  ' MAXIMUM LENGTH WE CAN HANDLE
IF %LENVAL <= %MAXLEN THEN GOTO =LENOK
OUTPUT
COLORS %WHITEX %BLUE                 ' MAKE ERROR MSG STAND OUT
'
OUTPUT VARIABLE %A1 IS TOO LONG TO EDIT WITH THIS PROGRAM
OUTPUT
STOP                                 ' TERMINATE PROGRAM
=LENOK
%VARVAL = LEFT %VARVAL %MAXLEN       ' PAD VARIABLE NAME TO LENGTH
'
COLORS %BLUE %WHITE                  ' BLUE ON WHITE FOR VAR NAME
OUTMSG %VNAME                        ' OUTPUT VARIABLE NAME AND = SIGN
COLORS %WHITEX %MAGENTA              ' COLORS FOR INPUT FIELD
INPUT %VARVAL                        ' LET OUR USER CHANGE THE VARIABLE
OUTPUT                               ' MOVE CURSOR DOWN A LINE
IF %EOI = 1 THEN GOTO =ESCKEY        ' USER PRESSED ESC KEY -- ABORT
%VARVAL = TRIM %VARVAL               ' REMOVE LEADING/TRAILING BLANKS
ENVSET P %A1 %VARVAL                 ' WRITE NEW ENV VARIABLE VALUE
OUTPUT
OUTPUT ********* NEW VALUE FOR %A1 HAS BEEN SET *********
OUTPUT
STOP
=NOARG
COLORS %WHITEX %BROWN
OUTPUT ********* ERROR -- NO ENVIRONMENT VARIABLE SPECIFIED **********
STOP
=ESCKEY
COLORS %WHITEX %BROWN
OUTPUT
OUTPUT ESCAPE KEY PRESSED -- NO CHANGES MADE TO %A1 VARIABLE
OUTPUT
STOP
'
=COLORSUB         ' SUB-ROUTINE TO ASSIGN MEANINGFUL NAMES TO COLORS
'
%BLACK    =  0    ' NOTE: IF YOU ADD 8 TO ANY OF THESE YOU
%BLUE     =  1    ' WILL GET THE SAME COLOR, ONLY BRIGHTER.
%GREEN    =  2
%CYAN     =  3
%RED      =  4
%MAGENTA  =  5
%BROWN    =  6
%WHITE    =  7
'                  **** BRIGHTER COLORS ****
%GRAY     =  8     ' A BRIGHT BLACK IS GRAY
%BLUEX    =  9
%GREENX   = 10     ' BRIGHT COLORS MAY ONLY BE USED IN THE FOREGROUND
%CYANX    = 11
%REDX     = 12
%MAGENTAX = 13
%YELLOW   = 14     ' A BRIGHT BROWN IS YELLOW
%WHITEX   = 15
'
RETURN
END
:SKIPBAX
