@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This is the simplest of the environment editors on the BAX     *
'* distribution disk.  It only edits the PATH variable.  It will  *
'* change your PATH variable if you exit by pressing the ENTER    *
'* key, so if you don't want your PATH variable changed, make     *
'* sure you exit with the ESCAPE key.  If your PATH variable is   *
'* longer than 75 characters, this program will not allow you to  *
'* change it.  BAX's input routine will only allow keyboard input *
'* up to 80 characters, so if you need to edit lines longer than  *
'* that, they would have to be split up into sections.            *
'*                                                                *
'******************************************************************
=PATHEDIT
'
%BLACK    =  0    ' NOTE: IF YOU ADD 8 TO ANY OF THESE YOU
%BLUE     =  1    ' WILL GET THE SAME COLOR, ONLY BRIGHTER.
%GREEN    =  2
%CYAN     =  3
%RED      =  4
%MAGENTA  =  5
%BROWN    =  6
%WHITE    =  7
'                  **** BRIGHTER COLORS ****
%GRAY     =  8     ' A BRIGHT BLACK IS GRAY
%BLUEX    =  9
%GREENX   = 10     ' BRIGHT COLORS MAY ONLY BE USED IN THE FOREGROUND
%CYANX    = 11
%REDX     = 12
%MAGENTAX = 13
%YELLOW   = 14     ' A BRIGHT BROWN IS YELLOW
%WHITEX   = 15
'
%S1 = LIT *****************************************************
%S2 = LIT *                 DOS PATH EDITOR                   *
%S3 = LIT *                                                   *
%S4 = LIT * PRESS ESCAPE TO ABORT WITHOUT MAKING CHANGES      *
%S5 = LIT * PRESS ENTER  TO SAVE CHANGES                      *
%S6 = LIT *                                                   *
%S7 = LIT *****************************************************
'
COLORS %BLACK %BROWN                 ' BACKGROUND SCREEN COLOR
CLS                                  ' PAINT SCREEN BROWN
COLORS  %RED %WHITE                  ' COLORS FOR INFO BOX
%X = 0
LOOP =BOTBOX                         ' LOOP TO DISPLAY BOX
%X = ADD %X 1
IF %X > 7 THEN LEAVE =BOTBOX
CURSORVH 0 15                        ' POSITION CURSOR AT COLUMN 15
OUTMSG %S%X                          ' OUTPUT THE LINE
OUTPUT                               ' MOVE TO BEGINNING OF NEXT LINE
=BOTBOX
OUTPUT                               ' BLANK LINE FOR COSMETICS
'
%P = ENVGET P PATH                   ' GET CURRENT PATH
%L = LEN %P                          ' GET LENGTH OF CURRENT PATH
IF %L < 76 THEN GOTO =ONWARD         ' SHORT ENOUGH TO EDIT
OUTPUT
COLORS %WHITEX %RED                  ' MAKE MSG STAND OUT
'
OUTPUT CURRENT PATH VARIABLE IS TOO LONG TO EDIT WITH THIS PROGRAM
OUTPUT
STOP
'
=ONWARD
%P = LEFT %P 75                      ' PAD BLANKS ON RIGHT
'
COLORS %YELLOW %RED                  ' COLORS FOR PROMPT STRING
OUTMSG PATH=                         ' DISPLAY PROMPT STRING
COLORS %WHITEX %MAGENTA              ' COLORS FOR INPUT FIELD
INPUT %P                             ' LET OUR USER CHANGE THE PATH
OUTPUT                               ' MOVE CURSOR DOWN ONE LINE
IF %EOI = 1 THEN GOTO =ESCKEY        ' USER PRESSED ESC KEY -- ABORT
%P = TRIM %P                         ' REMOVE LEADING/TRAILING BLANKS
ENVSET P PATH %P                     ' WRITE NEW PATH VARIABLE
OUTPUT                               ' BLANK LINE FOR COSMETICS
COLORS %WHITEX %GREEN
OUTPUT ********* NEW PATH HAS BEEN SET ***********
OUTPUT
STOP                                 ' ALL DONE -- TERMINATE
=ESCKEY
OUTPUT
COLORS %WHITEX %RED
OUTPUT ESCAPE KEY PRESSED -- NO CHANGES MADE TO PATH VARIABLE
OUTPUT
END
:SKIPBAX
