@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program shows a couple of techniques for initializing     *
'* and/or saving the contents of existing arrays.  This will      *
'* sometimes be necessary if you do a lot of parsing of different *
'* variables in a program.  If the list of double variables       *
'* required is fairly short, (< 10 or so), then you can often     *
'* handle it with a simple sub-routine call as shown in the       *
'* SAVER2 and SETSTARS sub-routines.  For longer lists, you need  *
'* to use a loop as shown in SAVER1.  Much of BAX's power comes   *
'* from the fact that double variables with the second one having *
'* a numeric value which can be used as a counter, function just  *
'* about the same as single dimension arrays which can be defined *
'* in more sophisticated high level languages such as BASIC, C,   *
'* PASCAL, etc.  It is well worth the time to learn how they work *
'* even though they might at first look a little complicated.     *
'*                                                                *
'******************************************************************
'
=AAAA                           ' BAX PROGRAM MUST START WITH A LABEL
'
CALL =SETSTARS * * * * * * * * * *  ' INIT OUR "S" ARRAY
'
CALL =SAVER1                    ' SAVE COMMAND LINE ARGS (METHOD 1)
'
CALL =DISPLAY                   ' DISPLAY BOTH SETS OF ARGUMENTS
'
CALL =SETSTARS * * * * * * * * * *  ' INIT OUR "S" ARRAY
'
CALL =SAVER2 %A1 %A2 %A3 %A4 %A5 %A6 %A7 %A8 %A9 %LA ' METHOD 2
'
CALL =DISPLAY                   ' DISPLAY BOTH SETS OF ARGUMENTS
STOP                            ' TERMINATE PROGRAM
'
=SAVER1
%SV = 0                         ' INIT COUNTER
LOOP =SAV1                      ' TOP OF LOOP
%SV = ADD %SV 1                 ' INCREMENT COUNTER
IF %SV > %LA THEN LEAVE =SAV1   ' BEYOND LAST VALUE, BREAK LOOP
%S%SV = %A%SV                   ' SAVE ARGUMENT
=SAV1                           ' BOTTOM OF LOOP
%SV = SUB %SV 1                 ' MAKE COUNTER = NUMBER OF VALUES
RETURN
'
=SAVER2 %S1 %S2 %S3 %S4 %S5 %S6 %S7 %S8 %S9 %SLAST
RETURN
'
=DISPLAY
'THE FOLLOWING LOOP DISPLAYS BOTH SET OF VALUES TO SHOW THAT THE
'SUB-ROUTINE WORKED.
OUTPUT                           'BLANK LINE FOR COSMETIC EFFECT
%X = 0                           'INIT COUNTER
LOOP =SHOWEM                     'TOP OF LOOP
%X = ADD %X 1                    'BUMP COUNTER
IF %X > %LA THEN LEAVE =SHOWEM   'NO MORE, BREAK LOOP
OUTPUT %S%X %A%X                 'DISPLAY BOTH SETS OF VALUES
=SHOWEM
RETURN
'
=SETSTARS %S1 %S2 %S3 %S4 %S5 %S6 %S7 %S8 %S9 %SLAST
RETURN
'
END                      'BAX PROGRAMS MUST END WITH AN END STATEMENT
:SKIPBAX
