@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This program demonstrates the use of the FILELIST, FILENAME,   *
'* and FILEDATA routines.                                         *
'* This program displays all files in the current directory with  *
'* BAT, COM or EXE extensions.  It could be modified to select    *
'* files according to much more complex selection criteria, and   *
'* of course what is done with the files selected is up to the    *
'* individual user.  In a demonstration program, not much can be  *
'* done except display things, but the selected files could be    *
'* deleted, renamed, moved to other directories, etc.             *
'*                                                                *
'* The extensions to test for are "hard coded" in this program,   *
'* but typically, in a program of this type, they would be        *
'* entered as command line arguments or selected from a menu.     *
'******************************************************************
=AAA                                   'MUST BEGIN WITH A LABEL
%A1 = .COM                             'EXTENSION 1
%A2 = .EXE                             'EXTENSION 2
%A3 = .BAT                             'EXTENSION 3
FILELIST *.*                           'GENERATE INTERNAL LIST OF FILES
LOOP =FFF                              'TOP OF LOOP
%FN = FILENAME                         'GET NEXT FILE NAME FROM LIST
IF %FN = %N THEN LEAVE =FFF            'BREAK LOOP WHEN THERE ARE NO MORE
%FEXT = RIGHT %FN 4                    'USE LAST FOUR AS EXTENSION
'
%TVAL = TEST %FEXT = %A1 %FEXT = %A2 %FEXT = %A3 'TEST FOR COM,EXE,BAT
'
IF %TVAL = 0 THEN GOTO =FFF            'ALL TESTS FAILED, SKIP FILE
%FINFO = FILEDATA %FN                  'DATE -- TIME -- SIZE -- ATTRIB
%FN = LEFT %FN 12                      'PAD FILENAME TO LENGTH OF 12
OUTPUT %FN %FINFO                      'DISPLAY FILENAME AND DATA
=FFF                                   'LOOP BACK AND DO ANOTHER ONE
FILELIST                               'RELEASE FILELIST MEMORY
END                                    'TERMINATE OUR BAX PROGRAM
:SKIPBAX
